function _get(obj, path) {
    if (path === "") {
        return obj;
    }
    var _a = "".concat(path).split("."), head = _a[0], tail = _a.slice(1);
    var safeObj = obj !== null && obj !== void 0 ? obj : {};
    if (tail.length === 0)
        return safeObj[head];
    return _get(safeObj[head], tail.join("."));
}
/**
 * A typesafe object getter, reading a path
 * @param obj The object to read from
 * @param path A path to a value within {@link obj}
 */
export function get(obj, path) {
    return _get(obj, path);
}
